<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: modules/recipesModule.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: modules/recipesModule.js</h1>






    <section>
        <article>
            <pre class="prettyprint source linenums"><code>let referenceToThis = null;

/**
 * The purpose of this function its to retreive the recipes
 *
 * @param {string} index - Index for offset which brings recipes from one thousand to one thousand
 * @param {string} previous - The array of recipes from previous iterations to concatenate all recipes in the same array.
 * @returns {Promise} Returns a new Promise object.
 */
const retrieveRecipes = function (index, previous) {
  return new Promise((resolve, reject) => {
    referenceToThis.recipes.get({
      limit: 1000,
      offset: index * 1000,
      related: 'garnishes, glass, ingredients, instructions, product',
    }).then((result) => {
      return resolve(result &amp;&amp; result.resource ? previous.concat(result.resource) : previous);
    }).catch((error) => {
      return reject(error);
    });
  });
};

// const compareStrings = function (baseString, includeString) {
//   return baseString.toLowerCase().includes(includeString.toLowerCase());
// };

/**
 * Makes calls to the table recipes one at a time synchronously.
 *
 * @returns {Promise} Returns a new Promise object.
 */
const synchronize = () => {
  return new Promise((resolve, reject) => {
    referenceToThis.recipes.get({count_only: true}).then((count) => {
      let chain = Promise.resolve();
      for (let index = 0; index &lt; Math.ceil(count / 1000); index++) {
        chain = chain.then((result) => {
          return retrieveRecipes(index, result ? result : []);
        });
      }

      return chain.then((result) => {
        return resolve(result);
      }).catch((error) => {
        return reject(error);
      });
    }).catch((error) => {
      return reject(error);
    });
  });
};

// const search = (array, value) => {
//   return new Promise((resolve, reject) => {
//     try {
//       return resolve(array.filter((recipe) => {
//         return recipe.name &amp;&amp; compareStrings(recipe.name, value) || recipe.published_name &amp;&amp; compareStrings(recipe.published_name, value);
//       }));
//     } catch (error) {
//       return reject(error);
//     }
//   });
// };

const recipesModule = (thisObject) => {
  referenceToThis = thisObject;
  referenceToThis.recipes.synchronize = synchronize;

  // referenceToThis.recipes.search = search;
};

export default recipesModule;
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Classes</h3><ul><li><a href="HttpClient.html">HttpClient</a></li><li><a href="MagentoClient.html">MagentoClient</a></li></ul><h3>Global</h3><ul><li><a href="global.html#addDocuments">addDocuments</a></li><li><a href="global.html#addProduct">addProduct</a></li><li><a href="global.html#addTags">addTags</a></li><li><a href="global.html#Channels-SDK_Example">Channels-SDK_Example</a></li><li><a href="global.html#Countries-SDK_Example">Countries-SDK_Example</a></li><li><a href="global.html#default">default</a></li><li><a href="global.html#Documents-SDK_Example">Documents-SDK_Example</a></li><li><a href="global.html#filter">filter</a></li><li><a href="global.html#generateEndpointsCrudMethods">generateEndpointsCrudMethods</a></li><li><a href="global.html#getProducts">getProducts</a></li><li><a href="global.html#getSalesPerson">getSalesPerson</a></li><li><a href="global.html#getTradeShows">getTradeShows</a></li><li><a href="global.html#importAndExecuteModules">importAndExecuteModules</a></li><li><a href="global.html#ProductCategories-SDK_Example">ProductCategories-SDK_Example</a></li><li><a href="global.html#Products-SDK_Example">Products-SDK_Example</a></li><li><a href="global.html#Recipes-SDK_Example">Recipes-SDK_Example</a></li><li><a href="global.html#removeTags">removeTags</a></li><li><a href="global.html#retrieveRecipes">retrieveRecipes</a></li><li><a href="global.html#SalesPerson-SDK_Example">SalesPerson-SDK_Example</a></li><li><a href="global.html#salesPersonModule">salesPersonModule</a></li><li><a href="global.html#SalesRepresentative-SDK_Example">SalesRepresentative-SDK_Example</a></li><li><a href="global.html#Samples-SDK_Example">Samples-SDK_Example</a></li><li><a href="global.html#setSalesPerson">setSalesPerson</a></li><li><a href="global.html#setTradeShow">setTradeShow</a></li><li><a href="global.html#synchronize">synchronize</a></li><li><a href="global.html#Tags-SDK_Example">Tags-SDK_Example</a></li><li><a href="global.html#Tradeshow-SDK_Example">Tradeshow-SDK_Example</a></li><li><a href="global.html#UserTypes-SDK_Example">UserTypes-SDK_Example</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.3</a> on Fri Nov 22 2019 13:09:48 GMT-0600 (Central Standard Time)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
